// ============================================================================================
// CN[ht@C
// ============================================================================================
#include "audioeffectx.h"

// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 0 //p[^̐

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyMinimumVST : public AudioEffectX
{
public:
	MyMinimumVST (audioMasterCallback audioMaster);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
};


// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyMinimumVST (audioMaster);
}

MyMinimumVST::MyMinimumVST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);         //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//L̊֐Ăяoɏs

}

void MyMinimumVST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* inL  =  inputs[0]; // p
	float* inR  =  inputs[1]; // Ep
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	for (int i = 0; i < sampleFrames; i++)
	{
		//ŉsB

		//o̓obt@֏ށB
		outL[i] = inL[i];
		outR[i] = inR[i];
	}
}